Imports System.Diagnostics

Public Module Module1
    Public Sub main()
        Dim Vehicles As New Tree(Of String)("Vehicle")
        With Vehicles
            With .Add("OnWater")
                .Add("SurfBoard")
                With .Add("Ship")
                    With .Add("Motorboat")
                        .Add("Steamboat")
                        .Add("Submarine")
                        .Add("Tanker").Add("Tanker2").Add("Tanker3")
                        .Add("Speedboat")
                    End With
                    With .Add("Sailboat")
                        .Add("Cog")
                        .Add("Frigate")
                        .Add("Catamaran")
                    End With
                End With
            End With
            With .Add("OnAir")
                .Add("Plane")
                With .Add("Rocket")
                    .Add("Challenger")
                    .Add("Apollo 13")
                End With
                .Add("Balloon")
            End With
            With .Add("OnEarth")
                .Add("Horse")
                With .Add("Car")
                    .Add("Trabant")
                End With
                .Add("Bike")
                .Add("Foot")
            End With
        End With
        EnumerateTree(Vehicles)

        ' Hier kann man die Ausgabe im Ausgabefenster angucken
        Stop
    End Sub

    Sub EnumerateTree(ByVal Parent As Tree(Of String))
        ' Rekursiver Durchgang zur Ausgabe im Ausgabefenster
        Debug.WriteLine(Parent.Value)

        ' mit Einrckung
        Debug.Indent()
        For Each Child As Tree(Of String) In Parent
            EnumerateTree(Child)
        Next
        Debug.Unindent()
    End Sub

End Module

